<?php

namespace Litecms\Legal\Actions;

use Illuminate\Support\Carbon;
use Illuminate\Support\Str;
use Litepie\Actions\Concerns\AsAction;
use Litecms\Legal\Models\Legal;


class LegalAction
{
    use AsAction;

    protected $model;
    protected $namespace = 'litecms.legal.legal';
    protected $eventClass = \Litecms\Legal\Events\LegalAction::class;
    protected $action;
    protected $function;
    protected $request;

    public function handle(string $action, Legal $legal, array $request = [])
    {
        $this->action = $action;
        $this->request = $request;
        $this->model = $legal;
        $this->function = Str::camel($action);
        $this->executeAction();
        return $this->model;

    }


    public function store(Legal $legal, array $request)
    {
        $attributes = $request;
        $attributes['user_id'] = user_id();
        $attributes['user_type'] = user_type();
        $legal = $legal->create($attributes);
        return $legal;
    }

    public function update(Legal $legal, array $request)
    {
        $attributes = $request;
        $legal->update($attributes);
        return $legal;
    }

    public function destroy(Legal $legal, array $request)
    {
        $legal->delete();
        return $legal;
    }

    public function copy(Legal $legal, array $request)
    {
        $count = $request['count'] ?: 1;

        if ($count == 1) {
            $legal = $legal->replicate();
            $legal->created_at = Carbon::now();
            $legal->save();
            return $legal;
        }

        for ($i = 1; $i <= $count; $i++) {
            $new = $legal->replicate();
            $new->created_at = Carbon::now();
            $new->save();
        }

        return $legal;
    }


}
