<?php

namespace Litecms\Legal\Policies;

use Litecms\Legal\Models\Legal;
use Illuminate\Foundation\Auth\User as Authenticatable;

trait LegalAction
{

    /**
     * Determine if the given user can copy the given legal.
     *
     * @param Authenticatable $user
     *
     * @return bool
     */
    public function copy(Authenticatable $user, Legal $legal)
    {

        if ($authUser->canDo('legal.legal.action.copy')) {
            return true;
        }

        $this->model->is_owner;
    }

    /**
     * Determine if the given user can empty the given legal.
     *
     * @param Authenticatable $user
     *
     * @return bool
     */
    function empty(Authenticatable $user, Legal $legal) {

        if ($authUser->canDo('legal.legal.action.empty')) {
            return true;
        }

        $this->model->is_owner;
    }

    /**
     * Determine if the given user can transfer the given legal.
     *
     * @param Authenticatable $user
     *
     * @return bool
     */
    public function transfer(Authenticatable $user, Legal $legal)
    {

        if ($authUser->canDo('legal.legal.action.transfer')) {
            return true;
        }

        $this->model->is_owner;
    }

}
