<?php

namespace Litecms\Legal\Policies;

use Litecms\Legal\Models\LegalCase;
use Illuminate\Foundation\Auth\User as Authenticatable;

trait LegalCaseWorkflow
{

    /**
     * Determine if the given user can approve the given legal_case.
     *
     * @param Authenticatable $user
     *
     * @return bool
     */
    public function approve(Authenticatable $user, LegalCase $legal_case)
    {
        if ($user->canDo('legal.legal_case.approve')) {
            return true;
        }

        return false;
    }

    /**
     * Determine if the given user can approve the given legal_case.
     *
     * @param Authenticatable $user
     *
     * @return bool
     */
    public function submit(Authenticatable $user, LegalCase $legal_case)
    {
        if ($user->canDo('legal.legal_case.submit')) {
            return true;
        }

        return false;
    }

    /**
     * Determine if the given user can approve the given legal_case.
     *
     * @param Authenticatable $user
     *
     * @return bool
     */
    public function publish(Authenticatable $user, LegalCase $legal_case)
    {
        if ($user->canDo('legal.legal_case.publish')) {
            return true;
        }

        return false;
    }

    /**
     * Determine if the given user can approve the given legal_case.
     *
     * @param Authenticatable $user
     *
     * @return bool
     */
    public function unpublish(Authenticatable $user, LegalCase $legal_case)
    {
        if ($user->canDo('legal.legal_case.unpublish')) {
            return true;
        }

        return false;
    }

    /**
     * Determine if the given user can approve the given legal_case.
     *
     * @param Authenticatable $user
     *
     * @return bool
     */
    public function archive(Authenticatable $user, LegalCase $legal_case)
    {
        if ($user->canDo('legal.legal_case.archive')) {
            return true;
        }

        return false;
    }

    /**
     * Determine if the given user can approve the given legal_case.
     *
     * @param Authenticatable $user
     *
     * @return bool
     */
    public function unarchive(Authenticatable $user, LegalCase $legal_case)
    {
        if ($user->canDo('legal.legal_case.unarchive')) {
            return true;
        }

        return false;
    }

    /**
     * Determine if the given user can approve the given legal_case.
     *
     * @param Authenticatable $user
     *
     * @return bool
     */
    public function reject(Authenticatable $user, LegalCase $legal_case)
    {
        if ($user->canDo('legal.legal_case.reject')) {
            return true;
        }

        return false;
    }

}
